var HNAP1_XMLNS = "http://purenetworks.com/HNAP1/";
var LOGIN = "Login";

var SOAP_OK = "OK";
var SOAP_ERROR = "ERROR";
var SOAP_REBOOT = "REBOOT";

document.write("<script src='js/hmac_md5.js'></script>")  

function getHnapAuth(SoapAction, privateKey)
{
	var current_time = new Date();
	var time_stamp = Math.round(current_time.getTime() / 1000);
	var auth = hex_hmac_md5(privateKey, time_stamp + SoapAction);
	
	return auth.toUpperCase() + " " + time_stamp;
}

function SoapClient()
{
	this.username = "";
	this.password = "";
}

SoapClient.prototype = 
{

READY_STATE_UNINITIALIZED 	: 0,
READY_STATE_LOADING 		: 1,
READY_STATE_LOADED 			: 2,
READY_STATE_INTERACTIVE 	: 3,
READY_STATE_COMPLETE 		: 4,

getXMLReq: function()
{
	var xmlReq = null;
	var msXMLList = new Array("Msxml4.XMLHTTP", "Msxml3.XMLHTTP", "Msxml2.XMLHTTP");

	if (window.XMLHttpRequest) // IE7+, Firefox, Chrome, Opera, Safari
	{ 
		xmlReq = new XMLHttpRequest();
	}
	else
	{
		if (window.ActiveXObject)	// IE 5 or 6
		{ 
	
			for (var i = 0; i < msXMLList.length; i++)
			{
				try 
				{
					xmlReq = new ActiveXObject(msXMLList[i]);
				}
				catch(e){}
			}
			
			try
			{
				if (xmlReq == null)
				{
					xmlReq = new ActiveXObject("Microsoft.XMLHTTP");
				}
			}
			catch(e){}
		}
	}

	return xmlReq;
},

sendRequest: function(method, parameters, callback, xmlns)
{
	var obj = this;
	var str = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
				"<soap:Envelope " +
				"xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" " +
				"xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" " +
				"xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
				"<soap:Body>" +
				"<" + method + " xmlns=\"";
	var privateKey = localStorage.getItem("PrivateKey");
	
	str	+= HNAP1_XMLNS;
	
	str +=  "\">" +
			parameters +
			"</" + method + "></soap:Body></soap:Envelope>";

	this.req = this.getXMLReq();
	this.callback = callback;

	if(this.req)
	{
		/* For compatibility with some versions of some Mozilla browsers, 
		 * to ensure that browsers can work properly.
		 */
		if (this.req.overrideMimeType)
		{
			this.req.overrideMimeType('text/xml');
		}

		this.req.onreadystatechange = function() {obj.onReadyState.call(obj)};				
		
		this.req.open('POST', "HNAP1/", true);		
		this.req.setRequestHeader("SOAPAction", '"' + HNAP1_XMLNS + method + '"');
		
		if (privateKey != null)
		{
			this.req.setRequestHeader("HNAP_AUTH", getHnapAuth('"' + HNAP1_XMLNS + method + '"', privateKey));
		}
		
		this.req.setRequestHeader("Cookie", sessionStorage.getItem("Cookie"));
		this.req.setRequestHeader("Content-Type", "text/xml; charset=utf-8");
		this.req.send(str);
	}
},

onReadyState: function()
{
	
	switch (this.req.readyState) 
	{
		case this.READY_STATE_UNINITIALIZED:
			break;
			
		case this.READY_STATE_LOADING:
			break;
			
		case this.READY_STATE_LOADED:
			break;
			
		case this.READY_STATE_INTERACTIVE:
			break;
			
		case this.READY_STATE_COMPLETE:
			if (this.req.status == 200)
			{
				this.callback.call(this, this.req);
			}				
			break;
		default:
			break;
	}	
}
}
